HDU 1069 Monkey and Banana(转换成LIS,做法很值得学习)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1069

Monkey and Banana

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 18739    Accepted Submission(s): 9967


Problem Description
A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
 
Input
The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.
 
Output
For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".
 
Sample Input
1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0
 
Sample Output
Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342
 
Source
题目大意:
研究人员为了研究猴子的IQ,把香蕉挂屋顶,然后准备了N个方块(每个方块随便你用多少个)猴子利用这些方块达成塔就能吃到香蕉。但是猴子要爬上塔肯定是要能有地方落脚的。所以2个方块在叠加的时候,下面的那块的长宽都必须严格大于上面一块,否则猴子没地方落脚爬不上去;
现在研究人员怕香蕉挂太高,搞得猴子吃不到。问你最高能搭成多少高。这样他们好确定香蕉的位置。

搭积木规则:
x要能搭在y积木上,要求x的底部面积小于y的底部面积(不能等于,只有小于 ,猴子才有落脚的地方)
分析:
1.每个积木有六个面,都可以当作底面,所以一个积木有6种不同的放法,我们把每种方法看成一个“积木”,由于严格的要求长宽必须要小于下面的那块木块,所以可以推出,一个木块(指的是分解完的木块)至多只能被用一次。因为长宽相同的木块不能叠加。
2.LIS问题,先按照底部面积排序,然后将高度做权值按照LIS问题的方法处理
 
状态转移:

dp[x]表示用上第x块木块时能搭的最高高度。

dp[i] = max(dp[i],dp[j]+a[i].z); j ∈[0,i-1];

边界条件(初始化):dp[i] = a[i].z (因为每个方块最优解至少比他自身的高度要高)

记得在状态转移前要加上条件(if(a[j].x > a[i].x && a[j].y > a[i].y))
#include<bits/stdc++.h>
using namespace std;
#define max_v 185
struct node
{
    int x,y,z;
};
bool cmp(node a,node b)
{
    return a.x*a.y>b.x*b.y;
}
struct node a[max_v];
int dp[max_v];
int main()
{
    int c=0,n;
    while(~ scanf("%d",&n))
    {
        if(n==0)
            break;
        for(int i=0; i<6*n;)
        {
            int x,y,z;
            scanf("%d %d %d",&x,&y,&z);
            a[i].x=x,a[i].y=y,a[i].z=z;
            i++;
            a[i].x=x,a[i].y=z,a[i].z=y;
            i++;
            a[i].x=y,a[i].y=x,a[i].z=z;
            i++;
            a[i].x=y,a[i].y=z,a[i].z=x;
            i++;
            a[i].x=z,a[i].y=y,a[i].z=x;
            i++;
            a[i].x=z,a[i].y=x,a[i].z=y;
            i++;
        }
        sort(a,a+6*n,cmp);
        dp[0]=a[0].z;
        //dp[i] 表示用上第i给木块能达到的最大高度
        for(int i=1; i<6*n; i++)
        {
            dp[i]=a[i].z;
            for(int j=0; j<i; j++)
            {
                if(a[i].x<a[j].x&&a[i].y<a[j].y)
                {
                   dp[i]=max(dp[i],dp[j]+a[i].z);
                }
            }
        }
        int t=0;
        for(int i=0; i<6*n; i++)
        {
            if(t<dp[i])
            {
                t=dp[i];
            }
        }
        printf("Case %d: maximum height = %d
",++c,t);
    }
}
原文地址:https://www.cnblogs.com/yinbiao/p/9150889.html